﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.C1Preview;
using C1.C1Report;

namespace MultiColumn_Report_C1PrintDocument
{
    public partial class ReportLoader : Form
    {
        C1.C1Preview.C1PrintDocument _cpdReportDoc;
        C1.Win.C1Preview.C1PrintPreviewControl _cppcPreviewControl;
        C1.C1Report.C1Report _c1rReport;
        string ReportType;

        public ReportLoader(string type)
        {
            InitializeComponent();
            ReportType = type;

            _cpdReportDoc = new C1.C1Preview.C1PrintDocument();
            _cppcPreviewControl = new C1.Win.C1Preview.C1PrintPreviewControl();
            _c1rReport = new C1.C1Report.C1Report();

            _cppcPreviewControl.Dock = DockStyle.Fill;

            this.Controls.Add(_cppcPreviewControl);
        }

           private void _C1PrintDocument()
        {
            C1.C1Preview.DataBinding.DataSource _dsDataBaseSource = new C1.C1Preview.DataBinding.DataSource();
            _dsDataBaseSource.ConnectionProperties.ConnectString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + @"\..\..\NWind.mdb;Persist Security Info=False";
            _dsDataBaseSource.ConnectionProperties.DataProvider = C1.C1Preview.DataBinding.DataProviderEnum.OLEDB;

            C1.C1Preview.DataBinding.DataSet _dsDataBaseSet = new C1.C1Preview.DataBinding.DataSet(_dsDataBaseSource, "Select TOP 66 * From Customers");

            _cpdReportDoc.DataSchema.DataSources.Add(_dsDataBaseSource);
            _cpdReportDoc.DataSchema.DataSets.Add(_dsDataBaseSet);

            RenderTable _rtTableHeading = new RenderTable();
            _rtTableHeading.Style.Padding.Bottom = "1cm";

            _rtTableHeading.Cells[0, 0].Style.TextColor = Color.Blue;
            _rtTableHeading.Cells[0, 0].Style.TextAlignHorz = AlignHorzEnum.Center;
            _rtTableHeading.Cells[0, 0].SpanCols = 8;
            _rtTableHeading.Cells[0, 0].Style.FontSize = 25;
            _rtTableHeading.Cells[0, 0].Style.FontBold = true;
            _rtTableHeading.Cells[0, 0].Style.FontUnderline = true;
            _rtTableHeading.Cells[0, 0].Text = "Customers Report";

            _rtTableHeading.Cells[1, 0].SpanCols = 8;
            _rtTableHeading.Cells[1, 0].Text = "           ";
            
            _rtTableHeading.RowGroups[2, 6].Style.FontSize = 18;
            _rtTableHeading.RowGroups[2, 6].Style.FontBold = true;
            _rtTableHeading.RowGroups[2, 6].Style.TextColor = Color.Red;
            _rtTableHeading.RowGroups[2, 6].Style.Borders.All = null;

            _rtTableHeading.Cols[0].Width = "1.8in";
            _rtTableHeading.Cols[1].Width = "1.5in";
            _rtTableHeading.Cols[2].Width = "1.5in";
            _rtTableHeading.Cols[3].Width = "1.5in";
            _rtTableHeading.Cols[4].Width = "1.8in";
            _rtTableHeading.Cols[5].Width = "1.5in";
            _rtTableHeading.Cols[6].Width = "1.5in";
            
            _rtTableHeading.Cells[2, 0].Text = "Customer ID";
            _rtTableHeading.Cells[2, 1].Text = "Name";
            _rtTableHeading.Cells[2, 1].Style.Padding.Left = "1cm";
            _rtTableHeading.Cells[2, 1].CellStyle.Padding.Left = "1cm";
            _rtTableHeading.Cells[2, 2].Text = "     Country";
            _rtTableHeading.Cells[2, 3].Text = "";
            _rtTableHeading.Cells[2, 3].CellStyle.BackColor = Color.White;
            _rtTableHeading.Cells[2, 4].Text = "Customer ID";
            _rtTableHeading.Cells[2, 5].Text = "  Name";
            _rtTableHeading.Cells[2, 6].Text = "    Country";


            RenderTable _rtTableofData = new RenderTable();

            _rtTableofData.Cols[0].Width = "1.5in";
            _rtTableofData.Cols[1].Width = "2in";
            _rtTableofData.Cols[2].Width = "1.5in";
            
            _rtTableofData.RowGroups[0, 3].DataBinding.DataSource = _dsDataBaseSet;
            _rtTableofData.RowGroups[0, 3].Style.FontSize = 15;
            _rtTableofData.Cells[0, 0].Text = "    [Fields!CustomerID.Value]";
            _rtTableofData.Cells[0, 1].Text = "[Fields!ContactName.Value]";
            _rtTableofData.Cells[0, 2].Text = "[Fields!Country.Value]";
            _cpdReportDoc.Body.Children.Add(_rtTableofData);

            C1.C1Preview.PageColumnDef _pcdCol1 = new PageColumnDef("13cm", "1cm");
            C1.C1Preview.PageColumnDef _pcdCol2 = new PageColumnDef("13cm", "0cm");

            _cpdReportDoc.PageLayout.Columns.Add(_pcdCol1);
            _cpdReportDoc.PageLayout.Columns.Add(_pcdCol2);

            _cpdReportDoc.PageLayout.PageHeader = _rtTableHeading;
            _cpdReportDoc.PageLayout.PageSettings.Width = "28cm";
            _cpdReportDoc.PageLayout.PageSettings.LeftMargin = "1cm";
            _cpdReportDoc.PageLayout.PageSettings.RightMargin = "1cm";
            _cpdReportDoc.Generate();

            this.Text = "MultiColumn Layout - C1PrintDocument";
            _cppcPreviewControl.Document = _cpdReportDoc;
        }

        private void _C1Report()
        {
            C1.C1Report.DataSource ds = _c1rReport.DataSource;
            ds.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + @"\..\..\NWind.mdb;Persist Security Info=False";
            ds.DataProvider = C1.C1Report.DataProvider.OLEDB;
            ds.RecordSource = "Select TOP 62 * From Customers";

            Layout l = _c1rReport.Layout;
            l.Columns = 2;
            l.ColumnLayout = ColumnLayoutEnum.Down;
            l.Orientation = OrientationEnum.Landscape;
            l.CustomWidth = 11.811 * 1440;
            l.CustomHeight = 11.811 * 1440;
            l.MarginLeft = 0.4 * 1440;
            l.MarginRight = 0.4 * 1440;
            l.MarginTop = 1 * 1440;
            l.MarginBottom = 1 * 1440;

            Section s = _c1rReport.Sections[SectionTypeEnum.Header];
            s.Height = 860;
            s.Visible = true;

            _c1rReport.Font.Bold = true;
            Field f = s.Fields.Add("FldTitle", "Customers Report", 0, 0, l.CustomWidth, 850);
            f.Font.Name = "Arial";
            f.Font.Size = 25;
            f.Font.Bold = true;
            f.Font.Underline = true;
            f.Align = FieldAlignEnum.CenterMiddle;
            f.ForeColor = Color.Blue;


            s = _c1rReport.Sections[SectionTypeEnum.PageHeader];
            s.Visible = true;
            s.Height = 1125;

            _c1rReport.Font.Size = 18;
            f = s.Fields.Add("LblCustomerID1", "Customer ID", 0, 50, 3000, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("LblName1", "Name", 3000, 50, 2000, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("LblCountry1", "Country", 5500, 50, 1500, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("LblCustomerID2", "Customer ID", 9000, 50, 3000, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("LblName2", "Name", 12000, 50, 2000, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("LblCountry2", "Country", 14500, 50, 2000, 1000);
            f.ForeColor = Color.Red;
            f.Align = FieldAlignEnum.LeftMiddle;


            s = _c1rReport.Sections[SectionTypeEnum.Detail];
            s.Height = 330;
            s.Visible = true;
            _c1rReport.Font.Bold = false;
            f = s.Fields.Add("FldCustomerID", "CustomerID", 0, 50, 2500, 330);
            f.Calculated = true;
            f.Font.Size = 15;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("FldContactName", "ContactName", 2500, 50, 3000, 330);
            f.Calculated = true;
            f.Font.Size = 15;
            f.Align = FieldAlignEnum.LeftMiddle;
            f = s.Fields.Add("FldCountry", "Country", 5500, 50, 2000, 330);
            f.Calculated = true;
            f.Font.Size = 15;
            f.Align = FieldAlignEnum.LeftMiddle;

            this.Text = "Multi-Column Layout - C1Report";
            _cppcPreviewControl.Document = _c1rReport;

        }

        private void ReportLoader_Load(object sender, EventArgs e)
        {
            if (ReportType == "C1Report")
            {
                _C1Report();
            }
            else
            {
                _C1PrintDocument();
            }
        }
    }
}
